package com.jln.common.config;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

import java.io.File;

/**
 * @author 86180
 * @version : CommonConfig, v 0.1 2020/1/15 9:57
 */
@Configuration
public class CommonConfig implements WebMvcConfigurer {
    private static final boolean isWindows = System.getProperty("os.name").toLowerCase().contains("win");
    private static final Logger log = LoggerFactory.getLogger(CommonConfig.class);
  /*  @Autowired
    private AuthenticationInterceptor authenticationInterceptor;*/
 /*   @Autowired
    private LoginUserHandlerMethodArgumentResolver loginUserHandlerMethodArgumentResolver;
*/
    @Value("${server.servlet.context-path}")
    public String contextPath;

   /* public void addInterceptors(InterceptorRegistry registry) {
        log.info("加载token验证配置类");
        registry.addInterceptor(authenticationInterceptor)
                .addPathPatterns("/**")
                .excludePathPatterns("/static/wf/**");//排除的静态资源
    }*/
 /*   @Override
    public void addArgumentResolvers(List<HandlerMethodArgumentResolver> argumentResolvers) {
        log.info("加载用户数据");
        argumentResolvers.add(loginUserHandlerMethodArgumentResolver);
    }*/
    @Override
    public void addResourceHandlers(ResourceHandlerRegistry registry) {

        log.info("加载swagger");
        registry.addResourceHandler("swagger-ui.html").addResourceLocations("classpath:/META-INF/resources/");
        registry.addResourceHandler("/webjars/**").addResourceLocations("classpath:/META-INF/resources/webjars/");
        registry.addResourceHandler("/file/**").addResourceLocations("classpath:/file/");
        registry.addResourceHandler("/static/**").addResourceLocations("classpath:/static/");
        if(isWindows){
            registry.addResourceHandler("/file/**").addResourceLocations("classpath:/file/");
        }else{
            File f = new File(this.getClass().getResource("").getPath());
            String path=f.toString();
            log.error("path:"+path);
            path=path.substring(0,path.lastIndexOf("."));
            path=path.substring(0,path.lastIndexOf("/"));
            path=path.substring(0,path.lastIndexOf("."));
            path=path.substring(0,path.lastIndexOf("/"));
            String judge="target";
//            int index = path.indexOf("target");
//            path=path.substring(0,index+judge.length());
            log.error("测试放行图片路径："+path);
            registry.addResourceHandler("/file/**").addResourceLocations(path+"/file/");
        }
    }
    //处理跨域
    @Override
    public void addCorsMappings(CorsRegistry registry) {
        registry.addMapping("/**")
                .allowedHeaders("*")
                .allowedMethods("*")
                .maxAge(3600)
                .allowedOrigins("*")
                .allowCredentials(true);
    }
}
