package com.jln.common.config;

import org.springframework.http.converter.HttpMessageConverter;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurationSupport;

import java.io.File;
import java.util.List;

/**
 * @author 86180
 * @version : JsonConfig, v 0.1 2020/3/3 11:27
 */
public class JsonConfig extends WebMvcConfigurationSupport {
    private static final boolean isWindows = System.getProperty("os.name").toLowerCase().contains("win");
    @Override
    protected void configureMessageConverters(List<HttpMessageConverter<?>> converters) {
        super.configureMessageConverters(converters);
        converters.add(new JacksonHttpMessageConverter());
    }
    @Override
    public void addResourceHandlers(ResourceHandlerRegistry registry) {

        registry.addResourceHandler("swagger-ui.html").addResourceLocations("classpath:/META-INF/resources/");
        registry.addResourceHandler("/webjars/**").addResourceLocations("classpath:/META-INF/resources/webjars/");
        registry.addResourceHandler("/file/**").addResourceLocations("classpath:/file/");
        if(isWindows){
            registry.addResourceHandler("/file/**").addResourceLocations("classpath:/file/");
        }else{
            File f = new File(this.getClass().getResource("").getPath());
            String path=f.toString();
            path=path.substring(0,path.lastIndexOf("."));
            path=path.substring(0,path.lastIndexOf("/"));
            path=path.substring(0,path.lastIndexOf("."));
            path=path.substring(0,path.lastIndexOf("/"));
            String judge="target";
//            int index = path.indexOf("target");
//            path=path.substring(0,index+judge.length());
            registry.addResourceHandler("/file/**").addResourceLocations(path+"/file/");
        }
    }

}
