package com.jln.common.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.util.List;

/**
 * @ClassName: 二维码参数封装类
 * @Description:
 * @Author:三刀 Date:2020/2/26 13:09
 * Version:1.0
 **/
@ApiModel("二维码参数封装")
@Data
public class QrParameter {

    @NotEmpty(message = "二维码要跳转的前端页面不能为空")
    @ApiModelProperty(example = "http://127.0.0.1:8010/mes/index.html", value = "前端要跳转的页面", required = true,dataType = "string")
    private String pageAddress;

    @NotEmpty(message = "请求接口位置不能为空")
    @ApiModelProperty(example = "http://127.0.0.1:8010/mes/getQr", value = "页面上面要请求接口位置", required = true,dataType = "string")
    private String apiUrl;

    @NotEmpty(message = "接口请求方式不能为空")
    @ApiModelProperty(example = "POST", value = "页面上面要请求接口方式", required = true,dataType = "string")
    private String requestMode;
    private List<QrParameterContent> parameter;     //参数集合
}
