package com.jln.common.entity;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.jln.common.enums.ResultCodeEnum;

/**
 * @author 86180
 * @version : Result, v 0.1 2020/1/17 11:08
 */
public class ResponseResult {

   @JsonProperty("response_uuid")
   private String responseUuid;

   @JsonProperty("response_time")
   private String responseTime;

   @JsonProperty("response_attr")
   private String responseAttr;

   private String message;

   private int code;

   public String getMessage() {
      return message;
   }


   public ResponseResult setMessage(String message) {
      this.message = message;
      return this;
   }

   public String getResponseUuid() {
      return responseUuid;
   }

   public void setResponseUuid(String responseUuid) {
      this.responseUuid = responseUuid;
   }

   public String getResponseTime() {
      return responseTime;
   }

   public void setResponseTime(String responseTime) {
      this.responseTime = responseTime;
   }

   public String getResponseAttr() {
      return responseAttr;
   }

   public void setResponseAttr(String responseAttr) {
      this.responseAttr = responseAttr;
   }

   public int getCode() {
      return code;
   }

   public ResponseResult setCode(int code) {
      this.code = code;
      return this;
   }

   public ResponseResult() {
   }

   /**
    * 成功且不带带返回信息
    *
    * @return
    */
   public ResponseResult toSuccess(String responseUuid, String responseTime) {
      this.setCode(ResultCodeEnum.OK.getCode());
      this.setMessage(ResultCodeEnum.SUCCESS.getMsg());
      this.setResponseUuid(responseUuid);
      this.setResponseTime(responseTime);
      this.setResponseAttr("");
      return this;
   }

   /**
    * 失败且带返回信息
    *
    * @return
    */
   public ResponseResult toFailure(String responseUuid, String responseTime, String message) {
      this.setCode(ResultCodeEnum.ERROR.getCode());
      this.setResponseUuid(responseUuid);
      this.setResponseTime(responseTime);
      this.setMessage(message);
      this.setResponseAttr("");
      return this;

   }

}
