package com.jln.common.entity;

import com.jln.system.web.action.sm.sm1001.entity.SysRole;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.util.List;

/**
 * @author 86180
 * @version : User, v 0.1 2020/2/15 12:06
 */
@Data
public class User {
    private static final long serialVersionUID = 1L;

    /**
     * 员工主键和用户主键一致
     */
    private Long employeeOid;

    /**
     * 员工编码
     */
    private String codeing;

    /**
     * 员工工号
     */
    private String jobNumber;

    /**
     * 员工电话号码
     */
    private String phone;

    /**
     * 0为男，1为女
     */
    private String sex;

    /**
     * 员工姓名
     */
    private String employeeName;

    /**
     * 员工籍贯
     */
    private String nativePlace;

    /**
     * 员工身份证号
     */
    private String idCard;

    /**
     * 入职时间
     */
    private LocalDateTime entryTime;

    /**
     * 离职时间
     */
    private LocalDateTime dimissionTime;

    /**
     * 0为启用，1为停用
     */
    private String blockUp;

    /**
     * 0为未删除，1为已删除
     */
    private Integer del;


    @ApiModelProperty(value = "用户主键")
    private Long userId;

    @ApiModelProperty(example = "张三",value = "用户名，登录名")
    private String userName;

    @ApiModelProperty(value = "员工编码，工号")
    private String employeeCode;

    @ApiModelProperty(value = "用户头像")
    private String photo;

    @ApiModelProperty(value = "用户密码策略",example = "123456")
    private Long paspolFk;

    @ApiModelProperty(value = "公司主键")
    private Long orgOid;

    @ApiModelProperty(value = "公司名称")
    private String orgName;

    @ApiModelProperty(value = "公司层级")
    private String orgClassCode;

    @ApiModelProperty(value = "部门主键")
    private Long divisionOid;

    @ApiModelProperty(value = "部门名称")
    private String divisionName;

    @ApiModelProperty(value = "部门层级")
    private String divisionClassCode;

    @ApiModelProperty(value = "岗位主键")
    private Long postOid;

    @ApiModelProperty(value = "主岗位名称")
    private String postName;

    @ApiModelProperty(value = "所属项目部")
    private Long xmwhFk;


    @ApiModelProperty(value = "角色")
    private List<SysRole> sysRoles;

}
