package com.jln.common.enums;

import com.baomidou.mybatisplus.core.enums.IEnum;

/**
 * 均值极差类型枚举
 */
public enum MeanRangeTypeEnum implements IEnum<String> {

	MEAN_VALUE("A2", "均值图-控制限计算系数"),
	RANGE_TYPE("D2", "极差R图-标准估计的除数"),
	RANGE_UCL_TYPE("D4", "极差R图-控制限计算系数-上限"),
	RANGE_LCL_TYPE("D3", "极差R图-控制限计算系数-下限"),
	MEAN_VALUE_TYPE("A2", "均值图-控制限计算系数"),
	STANDARD_DEVIATION_TYPE("C4", "标准差S图--标准差估计的除数"),
	STANDARD_DEVIATION_UCL_TYPE("B4", "标准差S图--控制限系数"),
	STANDARD_DEVIATION_LCL_TYPE("B3", "标准差S图--控制限系数"),
	SINGLE_VALUE("E2", "单值移动极差计算系数-上限");


	MeanRangeTypeEnum(String value, String desc) {
		this.value = value;
		this.desc = desc;
	}

	/**
	 * 值
	 */
	private String value;
	/**
	 * 描述
	 */
	private String desc;

	@Override
	public String getValue() {
		return value;
	}
}
