package com.jln.common.enums;

/**
 * @author 86180
 * @version : ResultCode, v 0.1 2020/1/17 11:16
 */
public enum ResultCodeEnum {
	/**
	 * 1** 信息，服务器收到请求，需要请求者继续执行操作
	 * 2** 成功，操作被成功接收并处理
	 * 3** 重定向，需要进一步的操作以完成请求
	 * 4** 客户端错误，请求包含语法错误或无法完成请求
	 * 5** 服务器错误，服务器在处理请求的过程中发生了错误
	 */
	OK(0,"ok"),
	NO(1,"no"),
	ERROR(-1,"exception"),
	FILE_REPETITION(10002, "字段名重复"),
	EULES_EXCEPITION(10004, "系统参数有误"),
	CODE_EXCEPTION(10001, "编码不符合规范"),
	SUCCESS(200, "success"),//成功
	FAILUTE(400, "error"),//失败
	UNAUTHORIZED(401, "验证失败"),//验证失败
	NOT_FOUND(404, "找不到"),//找不到
	NULL_POINTER_EXCEPTION(100001, "空指针引用异常"),
	CLASS_CAST_EXCEPTION(100002, "类型强制转换异常"),
	ILLEAGAL_ARGUMENT_EXCEPTION(100003, "传递非法参数异常"),
	ARITHMETIC_EXCEPTION(100004, "算术运算异常"),
	ARRAY_STORE_EXCEPTION(100005, "向数组中存放与声明类型不兼容对象异常"),
	INDEX_OUT_OF_BOUNDS_EXCEPTION(100006, "下标越界异常"),
	NEGATIVE_ARRAY_SIZE_EXCEPTION(100007, "创建一个大小为负数的数组错误异常"),
	NUMBER_FORMAT_EXCEPTION(100008, "数字格式异常"),
	SECURITY_EXCEPTION(100009, "安全异常"),
	UNSUPPORTED_OPERATION_EXCEPTION(100010, "不支持的操作异常"),
	LOOK_UP_TO(100011, "查无数据"),
	Expire_TOKEN(102006, "密钥失效"),
	CREATE_HASVALUE(101001, "已存在的名称，请重新输入后提交"),
	DELETE_EXCEPTION(101002, "删除失败，查无此记录"),
	UPDATE_EXCEPTION(101003, "更新异常，请根据提示确认后提交"),
	CREARE_FAILURE(101004, "插入失败"),

	MISS_PARAM(102001, "缺少必要参数，请检查输入数据"),
	Valid_PARAM(102002, "参数验证失败，请检查输入数据"),
	/**
	 * 参数解析
	 */
	Fail_PARAM(102003, "参数解析失败，请检查输入数据"),
	Not_SUPPORTED(102004, "不支持"),
	Not_TOKEN(102005, "密钥为空"),

	/**
	 * 附件上传失败
	 */
	File_Failure(102006, "附件上传失败"),
	File_DelFailure(102007, "附件删除失败"),
	Not_Data(102008, "没有获取到数据"),
	SQL_Error(102009, "SQL执行错误，请检查输入数据"),
	MISS_Fail(102010, "错误的请求上传接口，请检查是否输入文件"),
	Error_Fail(102011, "发生了预期之外的错误"),
	Long_Miss(102012, "Long类型不能为空，或者传入值不对"),
	/**
	 * 没有数据
	 */
	KBERROR1000(1000,"请传入物料编码"),
	IPC_Fail_Check(102013, "传入的任务已存在开工任务！"),
	IPC_Fail_Check2(102015, "只能暂停已开工的数据！"),
	START_SUCCESS(102014, "执行成功！"),

	/**
	 * BM
	 */
	BM0001(102016, "获取失败"),
	BM0003(102018, "保存失败"),
	BM0004(102019, "删除失败"),
	BM0007(102022, "删除失败"),
	BM0005(0, "删除成功"),
	BM0006(102020, "项目编码重复"),
	BM0008(102023, "编码重复"),
	BM0010(102025, "编码重复"),
	BM0009(102024, "请输入英文字母"),
	BM0011(102026, "该节点或该节点以下的节点被其他模块调用，删除失败"),
	BM0012(102027, "当前节点已被其他模块调用，修改其上级节点失败"),
	BM0013(102028, "当前设备已被调用，删除失败"),
	BM0002(102017, "字典编码重复");
	private int code;
	private String msg;

	ResultCodeEnum(int code, String msg) {
		this.code = code;
		this.msg = msg;
	}

	public int getCode() {
		return code;
	}

	public void setCode(int code) {
		this.code = code;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}
}