package com.jln.common.enums;

import com.baomidou.mybatisplus.core.enums.IEnum;
import com.jln.common.utils.StringUtils;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2020/9/1 10:58
 * Version:1.0
 **/
public enum SpcAbnormalTypeEnum implements IEnum<String> {

	ABNORMAL_BOUNDARY("1", "点出界--大于上限值或者小于下限值"),
	COMPANY_COMMANDER("2", "链长大于九---点的值同时九点出现在中心值的左侧或者右侧"),
	INCREASING_AND_DECREASING("3", "连续六点及以上递增或者递减");

	SpcAbnormalTypeEnum(String value, String desc) {
		this.value = value;
		this.desc = desc;
	}

	private String value;
	private String desc;

	@Override
	public String getValue() {
		return value;
	}

	/**
	 * 通过value取枚举
	 *
	 * @param value
	 * @return
	 */
	public static SpcAbnormalTypeEnum getTypeByValue(String value) {
		if (StringUtils.isNull(value)) {
			return null;
		}
		for (SpcAbnormalTypeEnum enums : SpcAbnormalTypeEnum.values()) {
			if (enums.getValue().equals(value)) {
				return enums;
			}
		}
		return null;
	}
}
