package com.jln.common.enums;


import java.util.ArrayList;
import java.util.List;

public enum WoStateColorEnum implements StateColor<String> {
    WO_INITIAL_KEY("PPK002", "I"),
    WO_AFFIRM_KEY("PPK003", "F"),
    WO_LEVELS_KEY("PPK004", "R"),
    WO_SUSPEND_KEY("PPK005", "S"),
    WO_ACCOMPLISH_KEY("PPK006", "C");
    WoStateColorEnum(String value, String desc) {
        this.desc = desc;
        this.value = value;
    }
    private String value;
    private String desc;

    @Override
    public String getValue() {
        return value;
    }

    public String getDesc() {
        return desc;
    }

    @Override
    public  List<String> getValues(){
        List<String> values=new ArrayList<>();
        for (WoStateColorEnum workOderEnum : WoStateColorEnum.values()) {
           values.add(workOderEnum.getValue());
        }
        return values;
    }

    @Override
    public  List<String> getDescs(){
        List<String> values=new ArrayList<>();
        for (WoStateColorEnum workOderEnum : WoStateColorEnum.values()) {
            values.add(workOderEnum.getDesc());
        }
        return values;
    }
}
