package com.jln.common.exception;

import com.jln.common.enums.ResultCodeEnum;

/**
 * @author 86180
 * @version : CustomException, v 0.1 2020/1/17 11:59
 */


/*
 * message
 *异常的描述信息，也就是在打印栈追踪信息时异常类名后面紧跟着的描述字符串
 *cause
 *导致此异常发生的父异常，即追踪信息里的caused by
 *enableSuppress
 *关于异常挂起的参数，这里我们永远设为false即可
 *writableStackTrace
 *表示是否生成栈追踪信息，只要将此参数设为false, 则在构造异常对象时就不会调用fillInStackTrace()
 * 生成”轻量级”异常，对性能的耗费从大到小依次为：输出到日志、获取异常堆栈、创建并 catch 异常
 * */
public class CustomException extends RuntimeException{
    private int code;
    private String msg;

    public CustomException(ResultCodeEnum resultCode) {
        super(resultCode.getMsg(),null,false,false);
        this.code = resultCode.getCode();
        this.msg = resultCode.getMsg();
    }

    public CustomException(int code, String msg) {
        super(msg,null,false,false);
        this.code = code;
        this.msg = msg;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }
}
