package com.jln.common.interceptor;

import com.alibaba.fastjson.JSON;
import com.jln.common.entity.ResponseResult;
import com.jln.common.entity.Result;
import org.springframework.core.MethodParameter;
import org.springframework.http.MediaType;
import org.springframework.http.server.ServerHttpRequest;
import org.springframework.http.server.ServerHttpResponse;
import org.springframework.web.bind.annotation.RestControllerAdvice;
import org.springframework.web.servlet.mvc.method.annotation.ResponseBodyAdvice;

/**
 * @author 86180
 * @version : MyResponseBodyAdvice, v 0.1 2020/1/31 10:03
 */
@RestControllerAdvice
public class MyResponseBodyAdvice implements ResponseBodyAdvice {
    @Override
    public boolean supports(MethodParameter returnType, Class converterType) {
        return true;
    }

    @Override
    public Object beforeBodyWrite(Object body, MethodParameter returnType, MediaType selectedContentType, Class selectedConverterType, ServerHttpRequest request, ServerHttpResponse response) {
        // 不处理swagger返回json格式
        String url = request.getURI().toString();
        if(url.contains("/v2/api-docs") || url.contains("/swagger-resources") || url.contains("/wf/modeleditor") || url.contains("/wf/procservice") || url.contains("proctrackimgs"))
        {
            return body;
        }
        if(body.equals(""))
        {
            return new Result().toSuccess();
        }
        if (body instanceof Result) {
            return body;
        }
        if (body instanceof String) {
            return JSON.toJSONString(new Result().toSuccess(body));
        }
        if (body instanceof ResponseResult) {
            return body;
        }
        return new Result().toSuccess(body);
    }
}
