package com.jln.common.utils;

import com.jln.common.constant.LocalDateTimeConst;
import lombok.extern.slf4j.Slf4j;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.UUID;

/**
 * @ClassName:  统用工具类
 * @Description:
 * @Author:三刀 Date:2020/2/4 14:56
 * Version:1.0
 **/
@Slf4j
public class BaseUtil {

    public Long getLongId(){
        SnowflakeIdWorker snowflakeIdWorker = new SnowflakeIdWorker(0,0);
        return snowflakeIdWorker.nextId();
    }
    /**
     * 获取32位UUID
     * @return
     */
    public static String getUuidRp() {
        String uuid = UUID.randomUUID().toString().replaceAll("-","");
        return uuid;
    }

    /**
     * 获取36位UUID
     * @return
     */
    public static String getUUID(){
        return UUID.randomUUID().toString();
    }

    public static String LocalDateToString() {
        LocalDate date = LocalDate.now();
        DateTimeFormatter fmt = DateTimeFormatter.ofPattern(LocalDateTimeConst.DATE_PATTERN);
        return date.format(fmt);
    }

    public  String getPath()
    {
        String path = this.getClass().getProtectionDomain().getCodeSource().getLocation().getPath();
        if(System.getProperty("os.name").contains("dows"))
        {
            path = path.substring(1,path.lastIndexOf("."));
            log.error(path);
        }
        if(path.contains("jar"))
        {
            log.error("jar"+path);
            path = path.substring(0,path.lastIndexOf("."));
            return path.substring(0,path.lastIndexOf("/"));
        }
        String replace = path.replace("target/classes/", "");
        replace= replace.substring(0,replace.lastIndexOf("."));
        log.error("replace"+replace);
        return replace.substring(0,replace.lastIndexOf("/"));
    }
    public static int objecttoint(BigDecimal o){
       // BigDecimal num = new BigDecimal(o);
        int num = o.intValue();
        System.out.println(num);
        return num;
    }
}
