package com.jln.common.utils;

import com.alibaba.fastjson.JSON;
import com.jln.common.constant.ApiConst;
import com.jln.common.entity.Result;
import com.jln.common.enums.CodeEnum;
import com.jln.common.enums.ResultCodeEnum;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.Map;

/**
 * 请求成功：返回编码值
 * 请求失败：返回-1
 * 需要自行判断是否返回成功
 */
public class GetCode {

    private static final String KEY = "codeType";

    /**
     * 调用系统管理接口生成编码
     * @return
     */
    public static Result<String> getCode(String value){
        ServletRequestAttributes requestAttributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
        HttpServletRequest httpServletRequest = requestAttributes.getRequest();
        Map<String, String> map = new HashMap<>(1);
        map.put(KEY, value);
        String s = HttpClientUtil.doGet(ApiConst.GET_CODE,
                map, httpServletRequest.getHeader("api_key"));
        Result result = JSON.parseObject(s, Result.class);
        if(!result.confirmSuccess()){
            return new Result<>().toFailure(ResultCodeEnum.FAILUTE).setMsg(CodeEnum.getDesc(value));
        }
        return result;
    }
}
