package com.jln.common.utils;

import com.google.common.collect.Maps;

import java.util.Map;

/**
 * @author 86180
 * @version : PropertiesUtil, v 0.1 2020/1/31 10:52
 */
public class PropertiesUtil {
    private static Map<String, String> map = Maps.newHashMap();
    private static PropertiesLoader loader = new PropertiesLoader(new String[]{"application-utils.properties"});

    public static String getConfig(String key) {
        String value = map.get(key);
        if (value == null) {
            value = loader.getProperty(key);
            map.put(key, value != null ? value : "");
        }
        return value;
    }

    public static Boolean isDebug() {
        String debug = getConfig("web.debug");
        return "true".equals(debug);
    }
}
