package com.jln.system.web.action.sm.sm1001.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * <p>
 * 角色表（岗位）
 * </p>
 *
 * @author 
 * @since 2020-04-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="SysRole对象", description="角色表（岗位）")
public class SysRole extends Model<SysRole> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "角色表主键")
    @TableId(value = "sys_role_id", type = IdType.INPUT)
    private Long sysRoleId;

    @NotBlank(message = "角色编码不能为空")
    @ApiModelProperty(value = "角色编码",example = "10001")
    private String roleCode;

    @NotBlank(message = "角色名称不能为空")
    @ApiModelProperty(value = "角色名称",example = "研发")
    private String roleName;

    @NotBlank(message = "角色英文名不能为空")
    @ApiModelProperty(value = "角色英文名称",example = "development")
    private String englishName;

   /* @ApiModelProperty(value = "父级角色，不继承父级角色的权限",example = "4696ca15-f7b0-4985-a794-e3fa961efd13")
    private String rolePid;*/

    @Length(max = 200,message = "备注不能超过两百字")
    @ApiModelProperty(value = "备注",example = "测试数据")
    private String remark;

    @TableLogic
    @ApiModelProperty(value = "是否删除，0存在，1删除",hidden = true)
    private Integer del;

    /*@ApiModelProperty(value = "是否为末级,Y是，N不是",required = true)
    private String lastStage;*/


    @Override
    protected Serializable pkVal() {
        return this.sysRoleId;
    }

}
