package com.jln.system.web.action.mqtt;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.mqtt.pojo.dto.JsonDataDto;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Component;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.*;

@Slf4j
@Component
public class Base64decrypt {

    @Autowired
    private MongoTemplate mongoTemplate;

    @Value("${jugeTime}")
    private Long jugeTime;

    @Value("${sleepTime}")
    private Long sleepTime;

    private Map<String,Object> findMongo( Map<String,Set<Map<String,Object>>> tableFiels ) {
        DateTimeFormatter fmDate = DateTimeFormatter.ofPattern("yyyyMM");
        String yearMonth = LocalDate.now().format(fmDate);
        Map<String,Object> map = new HashMap<>();
        for (Map.Entry<String, Set<Map<String, Object>>> stringSetEntry : tableFiels.entrySet()) {
            Query query = new Query();
            Map<String,String> mapper = new HashMap<>();
            for (Map<String, Object> stringStringMap : stringSetEntry.getValue()) {
                for (String s : stringStringMap.keySet()) {
                    query.fields().include(s);
                    mapper.put(s,stringStringMap.get(s).toString());
                }
            }

            query.fields().include("time");
            query.limit(1);
            query.with(Sort.by(
                    Sort.Order.desc("time")
            ));

            List<JSONObject> objectList = mongoTemplate.find(query, JSONObject.class, stringSetEntry.getKey()+yearMonth);
            //mongdb最新数据时间
            Map<String ,Object> map1 = objectList.get(0).toJavaObject(Map.class);
            for (Map.Entry<String, Object> stringObjectEntry : map1.entrySet()) {
                Object value = stringObjectEntry.getValue()==null?"":stringObjectEntry.getValue();
                map.put(mapper.get(stringObjectEntry.getKey()),value);
            }
        }
        map.remove(null);
       return  map;
    }


    /**
     * 机器人测试
     */
    public Map<String, Object> jqrSendString(JsonDataDto jsonDataDto, Map<String, Object> objectMap, long millis, Map<String, Object> reportDto) {
        Map<String, Object> mongoMap = findMongo(jsonDataDto.getTableFiels());
        mongoMap.forEach((key,value)->{
            if(key.equals("Status")){
                if(EmptyUtil.isEmpty(value) || "0".equals(value) || "".equals(value)){
                    mongoMap.put(key, "4");
                }
            }
        });
        for (String key : mongoMap.keySet()) {
            if(key.equals("Status") && (mongoMap.get(key).equals("4") || mongoMap.get(key).equals(4))) {
                List<Map<String,Object>> list = new ArrayList<>();
                Map<String,Object> map = new HashMap<>();
                map.put("Status","4");
                map.put("ts",millis);
                list.add(map);
                reportDto.put("reported",list);
                return reportDto;
            }
        }

        mongoMap.putAll(objectMap);
        millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, Object>> allDto = new ArrayList<>();
        Map<String,Object> sites = new HashMap<>();
        for (Map.Entry<String, Object> stringObjectEntry : objectMap.entrySet()) {
            Map<String,Object> properites = new HashMap<>();
            if(EmptyUtil.isEmpty(stringObjectEntry.getValue())){
                continue;
            }
            properites.put(stringObjectEntry.getKey(),stringObjectEntry.getValue());
            properites.put("ts",millis);
            allDto.add(properites);
        }
        try{
            Map<String,Object> treeMap = new HashMap<>();
            for (Map<String, Object> stringObjectMap : jsonDataDto.getTree()) {
                //循环key
                Set<Map.Entry<String, Object>> entrySet = stringObjectMap.entrySet();
                for (Map.Entry<String, Object> stringObjectEntry : entrySet) {
                    String value = JSON.toJSONString(stringObjectEntry.getValue());
                    try{
                        JSONObject jsonObject = JSONObject.parseObject(value);
                        Map<String,Object> keyValue = new HashMap<>();
                        for (Map.Entry<String, Object> objectEntry : jsonObject.entrySet()) {
                            Object zhi = mongoMap.get(objectEntry.getValue());
                            if(zhi==null || zhi.equals("")){
                                continue;
                            }
                            keyValue.put(String.valueOf(objectEntry.getValue()),zhi);
                        }
                        treeMap.put(stringObjectEntry.getKey(),keyValue);
                    }catch (Exception e){
                        Map<String,Object> keyValue = new HashMap<>();
                        Object zhi = mongoMap.get(stringObjectEntry.getValue());
                        if(zhi==null || zhi.equals("")){
                            continue;
                        }
                        keyValue.put(String.valueOf(stringObjectEntry.getValue()),zhi);
                        keyValue.put("ts",millis);
                        allDto.add(keyValue);
                    }
                }
            }
            allDto.add(treeMap);
        }catch (Exception e){
            System.out.println(e);
            Map<String, Object> site = new HashMap<>();
            site.put("Status", "2");
            site.put("ts", millis);
            allDto.add(site);
            reportDto.put("reported", allDto);
            reportDto.put("edgeTime", millis);
            return reportDto;
        }

        reportDto.put("reported", allDto);
        return reportDto;
    }

}
