package com.jln.system.web.action.mqtt.controller;


import com.jln.common.annotation.IgnoreUserLoginToken;
import com.jln.common.entity.Result;
import com.jln.system.web.action.mqtt.init.InitHander;
import com.jln.system.web.action.mqtt.pojo.dto.JsonDataDto;
import com.jln.system.web.action.mqtt.pojo.vo.StaticData;
import com.jln.system.web.action.mqtt.server.SendMqttServer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/mqtt/mqttclient")
@Api(tags = "mqtt连接")
public class MqttClientController {

    @Autowired
    private SendMqttServer sendMqttServer;

    @ApiOperation(value = "mqtt连接发布订阅", notes = "mqtt连接发布订阅")
    @PostMapping(value = "/start",consumes = "multipart/*", headers = "content-type=multipart/form-data")
    @IgnoreUserLoginToken
    public Result start(@RequestParam MultipartFile file) throws IOException {
        InitHander initHander = new InitHander();
        List<JsonDataDto> jsonDataDtoList = initHander.analysisJsonParm(file);
        if(jsonDataDtoList.isEmpty()){
            String initJson = initJson();
            return new Result().toFailure("标准格式:"+initJson);
        }
        sendMqttServer.sendMqtt(jsonDataDtoList);
        return new Result().toSuccess();
    }


    @ApiOperation(value = "redis查询数据", notes = "redis查询数据  1->板链线  2->奔腾切割机 3->梅塞尔52 4->梅塞尔53 5->小港机行车 6->校平机 7->数控龙门铣 8->400折弯机 9->大件坡口01 10->大件坡口02 其它返回null")
    @GetMapping("/findRedis")
    @IgnoreUserLoginToken
    public Result findRedis(@RequestParam("ID") Integer id) {
        Map<String, Object> list = null;
        if (id.equals(1)) {
//            list = redisUtil.hmget("blx");
            list = StaticData.data.get("blx");
        } else if (id.equals(2)) {
//            list = redisUtil.hmget("jgqgj");
            list = StaticData.data.get("jgqgj");
        } else if (id.equals(3)) {
//            list = redisUtil.hmget("mse52");
            list = StaticData.data.get("mse52");
        } else if (id.equals(4)) {
            // list = redisUtil.hmget("mse53");
            list = StaticData.data.get("mse53");
        } else if (id.equals(5)) {
//            list = redisUtil.hmget("xgjxc");
            list = StaticData.data.get("xgjxc");
        } else if (id.equals(6)) {
//            list = redisUtil.hmget("xpj");
            list = StaticData.data.get("xpj");
        } else if (id.equals(7)) {
//            list = redisUtil.hmget("sklmx");
            list = StaticData.data.get("sklmx");
        } else if (id.equals(8)) {
//            list = redisUtil.hmget("400zwj");
            list = StaticData.data.get("400zwj");
        } else if (id.equals(9)) {
//            list = redisUtil.hmget("djpk01");
            list = StaticData.data.get("djpk01");
        } else if (id.equals(10)) {
//            list = redisUtil.hmget("djpk02");
            list = StaticData.data.get("djpk02");
        }else if (id.equals(11)) {
            list = StaticData.data.get("skpmz");
        }else if(id.equals(12)){
            list = StaticData.data.get("800zwj");
        }
        return new Result().toSuccess(list);
    }

    private String initJson(){
        String jsonStr="[\n" +
                "    {\n" +
                "        \"skurl\":\"\\\\cacert\\\\test.sk\",\n" +
                "        \"txtFileUrl\":\"\\\\cacert\\\\cjdqzdtqsb1.txt\",\n" +
                "        \"mongdbTableb\":\"chejiashebeibianliang\",\n" +
                "        \"clientUuid\":\"5003820063\",\n" +
                "        \"cmdId\":\"10\",\n" +
                "        \"productKey\":\"PaintRobot\",\n" +
                "        \"sequenceId\":1,\n" +
                "        \"reported\":{\n" +
                "            \"singleField\":[\n" +
                "                {\n" +
                "                    \"subTable\":\"chejiashebeibianliang03\",\n" +
                "                    \"feilds\":[\n" +
                "                        {\n" +
                "                            \"dbField\":\"d141\",\n" +
                "                            \"fieldDataType\":\"FLOAT\",\n" +
                "                            \"iotField\":\"GroupDistr\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                },\n" +
                "                {\n" +
                "                    \"subTable\":\"chejiashebeibianliang04\",\n" +
                "                    \"feilds\":[\n" +
                "                        {\n" +
                "                            \"dbField\":\"d142\",\n" +
                "                            \"fieldDataType\":\"FLOAT\",\n" +
                "                            \"iotField\":\"SolidFlow\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d143\",\n" +
                "                            \"fieldDataType\":\"FLOAT\",\n" +
                "                            \"iotField\":\"SolidContent\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d144\",\n" +
                "                            \"fieldDataType\":\"INT\",\n" +
                "                            \"iotField\":\"PowTime\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d145\",\n" +
                "                            \"fieldDataType\":\"INT\",\n" +
                "                            \"iotField\":\"Alarm\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d146\",\n" +
                "                            \"fieldDataType\":\"STRING\",\n" +
                "                            \"iotField\":\"AlarmMsg\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d147\",\n" +
                "                            \"fieldDataType\":\"FLOAT\",\n" +
                "                            \"iotField\":\"PaintFlow\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d148\",\n" +
                "                            \"fieldDataType\":\"FLOAT\",\n" +
                "                            \"iotField\":\"PaintValu\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d149\",\n" +
                "                            \"fieldDataType\":\"INT\",\n" +
                "                            \"iotField\":\"Status\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                }\n" +
                "            ]\n" +
                "        }\n" +
                "    }\n" +
                "]";
        return jsonStr;
    }

}
