package com.jln.system.web.action.mqtt.init;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.mqtt.pojo.dto.JsonDataDto;
import com.jln.system.web.action.mqtt.util.FlieUrlUtil;
import org.springframework.boot.CommandLineRunner;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.*;

public class InitHander implements CommandLineRunner {

    @Override
    public void run(String... args){

    }
    public List<JsonDataDto> analysisJsonParm(MultipartFile file) throws IOException {

        String jsonStr = FlieUrlUtil.readJsonField(file);
        //String jsonStr = strJson();//模拟数据
        List<JsonDataDto> jsonDataDtoList = new ArrayList<>();

            List<JSONObject> list = JSONObject.parseObject(JSONArray.parseArray(jsonStr).toString(), List.class);
            list.forEach(j->{
                JsonDataDto jsonDataDto = new JsonDataDto();
                List<Map<String,Object>> tree = new ArrayList<>();
                List<JSONObject> mongdbTableList= JSONObject.parseObject(j.getJSONObject("reported").getJSONArray("singleField").toString(), List.class);
                jsonDataDto.setCmdId(Integer.parseInt(j.get("cmdId").toString()));
                jsonDataDto.setMongdbTableb(j.get("mongdbTableb").toString());
                jsonDataDto.setSequenceId(Integer.parseInt(j.get("sequenceId").toString()));
                jsonDataDto.setProductKey(j.get("productKey").toString());
                jsonDataDto.setSkurl(j.get("skurl").toString());
                jsonDataDto.setTxtFileUrl(j.get("txtFileUrl").toString());
                jsonDataDto.setClientUuid(j.get("clientUuid").toString());

                Map<String,Set<Map<String,Object>>> tableMap = new HashMap<>();//存储表名、对象

                mongdbTableList.forEach(t->{
                    //处理字段
                    List<JSONObject> feildslist = JSONObject.parseObject(String.valueOf(t.getJSONArray("feilds")), List.class);
                    if(!EmptyUtil.isEmpty(feildslist)){
                        for (JSONObject jsonObject : feildslist) {
                            Map<String,Object> objectMap = new HashMap<>();
                            for (String key : jsonObject.keySet()) {

                                Map<String,Object> fildsMap = new HashMap<>();//存储mongo字段、iot字段
                                List<JSONObject> objectList =  JSONObject.parseObject(jsonObject.get(key).toString(), List.class);
                                for (JSONObject object : objectList) {
                                    String dbField = object.get("dbField").toString();//查询的表字段
                                    String iotField = object.get("iotField").toString();//给iot 的字段
                                    String tableName = object.get("subTable").toString();//表名

                                    fildsMap.put(dbField,iotField);

                                    Map<String,Object> mapping = new HashMap<>();
                                    mapping.put(dbField,iotField);

                                    //根据表名判断对应的set集合是否存在不存在则新增set集合   set集合存放mongo字段和iot字段
                                    if(EmptyUtil.isEmpty(tableMap.get(tableName))){
                                        Set<Map<String,Object>> set = new LinkedHashSet<>();
                                        set.add(mapping);
                                        tableMap.put(tableName,set);
                                    }else{

                                        tableMap.get(tableName).add(mapping);
                                    }
                                }
                                objectMap.put(key,fildsMap);
                            }
                            tree.add(objectMap);
                        }
                    }else{
                        String dbField = t.get("dbField").toString();//查询的表字段
                        String iotField = t.get("iotField").toString();//给iot 的字段
                        String tableName = t.get("subTable").toString();//表名

                        Map<String,Object> mapping = new HashMap<>();
                        mapping.put(dbField,iotField);

                        //根据表名判断对应的set集合是否存在不存在则新增set集合   set集合存放mongo字段和iot字段
                        if(EmptyUtil.isEmpty(tableMap.get(tableName))){

                            Set<Map<String,Object>> set = new LinkedHashSet<>();
                            set.add(mapping);
                            tableMap.put(tableName,set);
                        }else{
                            tableMap.get(tableName).add(mapping);
                        }
                        tree.add(mapping);
                    }
                    jsonDataDto.setTableFiels(tableMap);
                    jsonDataDto.setTree(tree);
                });
                jsonDataDtoList.add(jsonDataDto);
                //查询数据
            });
        return jsonDataDtoList;
    }

    public static void main(String[] args) {
        //analysisJsonParm();
    }
    private static  String strJson (){
        String str ="[\n" +
                "    {\n" +
                "        \"skurl\":\"\\\\cacert\\\\test.sk\",\n" +
                "\t\t\"txtFileUrl\":\"\\\\cacert\\\\ptjqr1.txt\",\n" +
                "        \"mongdbTableb\":\"zhengchangshujushebei\",\n" +
                "        \"clientUuid\":\"5003820077\",\n" +
                "        \"cmdId\":\"10\",\n" +
                "        \"productKey\":\"PaintRobot\",\n" +
                "        \"sequenceId\":1,\n" +
                "        \"reported\":{\n" +
                "            \"singleField\":[\n" +
                "                {\n" +
                "                    \"subTable\":\"zhengchangshujushebei01\",\n" +
                "                    \"feilds\":[\n" +
                "                        {\n" +
                "                            \"dbField\":\"d1\",\n" +
                "                            \"fieldDataType\":\"Int\",\n" +
                "                            \"iotField\":\"设备1IOT1\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d2\",\n" +
                "                            \"fieldDataType\":\"String\",\n" +
                "                            \"iotField\":\"设备1IOT2\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                },\n" +
                "                {\n" +
                "                    \"subTable\":\"zhengchangshujushebei02\",\n" +
                "                    \"feilds\":[\n" +
                "                      {\n" +
                "                            \"dbField\":\"d51\",\n" +
                "                            \"fieldDataType\":\"Int\",\n" +
                "                            \"iotField\":\"设备1IOT3\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d52\",\n" +
                "                            \"fieldDataType\":\"String\",\n" +
                "                            \"iotField\":\"设备1IOT4\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                }\n" +
                "            ]\n" +
                "        }\n" +
                "    },\n" +
                "\t{\n" +
                "        \"skurl\":\"\\\\cacert\\\\test.sk\",\n" +
                "\t\t\"txtFileUrl\":\"\\\\cacert\\\\sklmx.txt\",\n" +
                "        \"mongdbTableb\":\"chejiashebeibianliang\",\n" +
                "        \"clientUuid\":\"5003820077\",\n" +
                "        \"cmdId\":\"10\",\n" +
                "        \"productKey\":\"PaintRobot\",\n" +
                "        \"sequenceId\":1,\n" +
                "        \"reported\":{\n" +
                "            \"singleField\":[\n" +
                "                {\n" +
                "                    \"subTable\":\"chejiashebeibianliang01\",\n" +
                "                    \"feilds\":[\n" +
                "                        {\n" +
                "                            \"dbField\":\"d11\",\n" +
                "                            \"fieldDataType\":\"Int\",\n" +
                "                            \"iotField\":\"设备2IOT1\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d2\",\n" +
                "                            \"fieldDataType\":\"String\",\n" +
                "                            \"iotField\":\"设备2IOT2\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                },\n" +
                "                {\n" +
                "                    \"subTable\":\"chejiashebeibianliang02\",\n" +
                "                    \"feilds\":[\n" +
                "                      {\n" +
                "                            \"dbField\":\"d51\",\n" +
                "                            \"fieldDataType\":\"Int\",\n" +
                "                            \"iotField\":\"设备2IOT4\"\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"dbField\":\"d52\",\n" +
                "                            \"fieldDataType\":\"String\",\n" +
                "                            \"iotField\":\"设备2IOT5\"\n" +
                "                        }\n" +
                "                    ]\n" +
                "                }\n" +
                "            ]\n" +
                "        }\n" +
                "    }\n" +
                "]";
        return str;
    }
}
