package com.jln.system.web.action.mqtt.server.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.system.web.action.mqtt.mappermes.EoStatisticsMapper;
import com.jln.system.web.action.mqtt.pojo.entity.EoStatistics;
import com.jln.system.web.action.mqtt.server.EoStatisticsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.locks.ReentrantLock;
@Service
public class EoStatisticsServiceImpl extends ServiceImpl<EoStatisticsMapper, EoStatistics> implements EoStatisticsService{

    //记录日期
    private Map<String,Date> map = new HashMap();

    private final ReentrantLock lock = new ReentrantLock();

    @Autowired
    private EoStatisticsMapper mapper;

    @Override
    public boolean isFlag(Map<String, Object> objectMap,EoStatistics eo) {
        lock.lock();
        eo.setGzsc(0);
        eo.setLxsc(0);
        eo.setZysc(0);
        eo.setDjsc(0);
        //当前时间
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Date date = new Date();
        String tm = dateFormat.format(date);
        try{
            date = dateFormat.parse(tm);
            List<Map<String, String>> ob =(List) objectMap.get("reported");
            if (ob!=null){
                for (int i=0;i<ob.size();i++){
                    if (ob.get(i).get("Status")!=null){
                        Integer zt = Integer.parseInt(ob.get(i).get("Status"));
                        switch (zt) {
                            case 1:
                                eo.setZysc(2);
                                break;
                            case 2:
                                eo.setDjsc(2);
                                break;
                            case 3:
                                eo.setGzsc(2);
                                break;
                            case 4:
                                eo.setLxsc(2);
                                break;
                        }
                        eo.setNowdata(date);
                    }
                }
            }

            //判断变量是否有日期
            if(map.get(eo.getSb())!=null){
                if(map.get(eo.getSb()).equals(date)){
                    //修改数据
                    mapper.isFlag(eo);
                }else{
                    //查询数据
                    EoStatistics eoStatistics = this.getOne(new LambdaQueryWrapper<EoStatistics>()
                            .eq(EoStatistics::getNowdata,tm).eq(EoStatistics::getSb,eo.getSb()));

                    //判断有没有数据
                    if(eoStatistics == null){
                        //创建今天的表 默认值设置
                        eo.setEoStatisticsoid(new Date().getTime());
                        if(eo.getLxsc()==null){
                            eo.setLxsc(0);
                        }
                        if(eo.getGzsc()==null){
                            eo.setGzsc(0);
                        }
                        if(eo.getDjsc()==null){
                            eo.setDjsc(0);
                        }
                        if(eo.getZysc()==null){
                            eo.setZysc(0);
                        }
                        eo.setNowdata(date);
                        this.save(eo);
                        map.put(eoStatistics.getSb(),eoStatistics.getNowdata());
                    }else{
                        //把时间保存到变量中
                        mapper.isFlag(eo);
                        map.put(eoStatistics.getSb(),eoStatistics.getNowdata());
                    }
                }
            }else{
                //查询数据
                EoStatistics eoStatistics = this.getOne(new LambdaQueryWrapper<EoStatistics>()
                        .eq(EoStatistics::getNowdata,tm).eq(EoStatistics::getSb,eo.getSb()));
                //判断有没有数据
                if(eoStatistics == null){
                    //创建今天的表 默认值设置
                    eo.setEoStatisticsoid(new Date().getTime());
                    if(eo.getLxsc()==null){
                        eo.setLxsc(0);
                    }
                    if(eo.getGzsc()==null){
                        eo.setGzsc(0);
                    }
                    if(eo.getDjsc()==null){
                        eo.setDjsc(0);
                    }
                    if(eo.getZysc()==null){
                        eo.setZysc(0);
                    }
                    eo.setNowdata(date);
                    this.save(eo);
                }else{
                    //把时间保存到变量中
                    map.put(eoStatistics.getSb(),eoStatistics.getNowdata());
                    mapper.isFlag(eo);
                }

            }


        }catch (Exception e){
            e.getMessage();
        }finally {
            lock.unlock();
        }
        return false;
    }
}
