package com.jln.system.web.action.sm.user.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.PageParameter;
import com.jln.system.web.action.sm.user.entity.SysEmployee;
import com.jln.system.web.action.sm.user.mapper.SysEmployeeMapper;
import com.jln.system.web.action.sm.user.pojo.vo.EmpListVo;
import com.jln.system.web.action.sm.user.service.SysEmployeeService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author 
 * @since 2020-02-15
 */
@Service
public class SysEmployeeServiceImpl extends ServiceImpl<SysEmployeeMapper, SysEmployee> implements SysEmployeeService {

    @Override
    public String getEmpNameByoid(Long oid) {
        if(EmptyUtil.isEmpty(oid)){
            return null;
        }
        LambdaQueryWrapper<SysEmployee> wrapper=new LambdaQueryWrapper<>();
        wrapper.select(SysEmployee::getEmployeeName);
        wrapper.eq(SysEmployee::getEmployeeOid,oid);
        SysEmployee employee = getOne(wrapper);
        if(EmptyUtil.isEmpty(employee)){
            return null;
        }
        return employee.getEmployeeName();
    }

    @Override
    public Result<Page<EmpListVo>> getlist(PageParameter parameter) {
        LambdaQueryWrapper<SysEmployee> wrapper=new LambdaQueryWrapper<>();
        wrapper.select(SysEmployee::getJobNumber,SysEmployee::getEmployeeOid,SysEmployee::getEmployeeName,SysEmployee::getCodeing);
        Page<SysEmployee> employeePage = page(new Page<>(parameter.getPageNum(), parameter.getPageSize()), wrapper);
        if(0==employeePage.getTotal()){
            return new Result().toSuccess(new Page<EmpListVo>());
        }
        List<EmpListVo> employees=new ArrayList<>();
        Page<EmpListVo> empListVoPage=new Page<>();
        BeanUtils.copyProperties(employeePage,empListVoPage);
        for (SysEmployee record : employeePage.getRecords()) {
            EmpListVo listVo = new EmpListVo();
            BeanUtils.copyProperties(record,listVo);
            employees.add(listVo);
        }
        empListVoPage.setRecords(employees);
        return new Result<Page<EmpListVo>>().toSuccess().setData(empListVoPage);
    }
}
