package com.jln.system.web.config;

import com.baomidou.mybatisplus.core.MybatisConfiguration;
import com.baomidou.mybatisplus.extension.plugins.PaginationInterceptor;
import com.baomidou.mybatisplus.extension.spring.MybatisSqlSessionFactoryBean;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;

import javax.annotation.Resource;
import javax.sql.DataSource;

/**
 * @author 86180
 * @version : MyBatisConfigTwo, v 0.1 2020/5/9 11:46
 */
@Configuration
@MapperScan(basePackages = "com.jln.system.web.action.**.mappermes",sqlSessionFactoryRef = "sqlSessionFactory2")
public class MyBatisConfigTwo {
    @Resource(name = "dbTwo")
    DataSource dbTwo;
    @Bean
    SqlSessionFactory sqlSessionFactory2()throws Exception {
        MybatisSqlSessionFactoryBean bean = new MybatisSqlSessionFactoryBean();
        MybatisConfiguration mybatisConfiguration = new MybatisConfiguration();
        mybatisConfiguration.addInterceptor(new PaginationInterceptor());
        mybatisConfiguration.setLogImpl(org.apache.ibatis.logging.stdout.StdOutImpl.class);
        bean.setConfiguration(mybatisConfiguration);
        bean.setDataSource(dbTwo);
        bean.setTypeAliasesPackage("com.jln.system.web.action.**.mappermes");
        bean.setMapperLocations(new PathMatchingResourcePatternResolver().getResources("classpath*:/mappermes/*/*.xml"));
        return bean.getObject();
    }
    @Bean
    public DataSourceTransactionManager sqlserverSbkbTransactionManager() {
        return new DataSourceTransactionManager(dbTwo);
    }
    @Bean
    SqlSessionTemplate sqlSessionTemplate2()throws Exception {
        return new SqlSessionTemplate(sqlSessionFactory2());
    }
}
