package com.jln.system.web.utils;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 规则表
 * </p>
 *
 * @author 8160
 * @since 2020-06-02
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="Actionrule对象", description="规则表")
public class Actionrule extends Model<Actionrule> {

    private static final long serialVersionUID = 1L;

    @TableId
    @ApiModelProperty(value = "规则id")
    private String gzId;

    @ApiModelProperty(value = "规则名称")
    private String name;

    @ApiModelProperty(value = "规则类型")
    private String type;

    @ApiModelProperty(value = "表名")
    private String tableName;

    @ApiModelProperty(value = "列名")
    private String columnName;

    @ApiModelProperty(value = "操作符")
    private String operation;

    @ApiModelProperty(value = "值")
    private String value;

    @ApiModelProperty(value = "操作id")
    private String actionId;

    @ApiModelProperty(value = "创建人id")
    private String createby;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createtime;


    @Override
    protected Serializable pkVal() {
        return this.gzId;
    }

}
